<template>
  <div>
    <!-- Contenido -->
    <div class="contSecc">
      <!-- DIALOG -->
      <div>
        <v-row>
          <v-dialog
            v-model="usuario"
            max-width="800px"
            max-height="600px"
            style="
    background-color: #fafafa; transform-origin: center center;max-width: 800px;max-height: 600px;"
          >
            <v-card>
              <v-card-title>
                <b style="text-align:left;">Nueva visita</b>
              </v-card-title>
              <div
                style="background-color: rgb(255, 205, 0);width: 96%;height: 3px;margin-left: 2%;"
              ></div>
              <div class="contModal tCenter" style="margin-top: -20px;">
                <v-card-text>
                  <div
                    class="titCampos"
                    style="text-align: left;margin-left: -15px;"
                  >
                    <b>Ingresa la información para realizar una nueva visita</b>
                  </div>
                </v-card-text>
                <v-row>
                  <v-card-text>
                    <!-- USUARIO -->
                    <div class="titCampos" style="margin-top: -20px;">
                      Usuario a asignar:
                    </div>
                    <v-autocomplete
                      outlined
                      ref="userValue"
                      v-model="usuarioSeleccionado"
                      :items="metadata.usuarios"
                      item-value="dato_busqueda"
                      item-text="dato_busqueda"
                      dense
                      hide-no-data
                      placeholder="Busca por número de empleado"
                      append-icon
                      :search-input.sync="textoUsuarioIngresado"
                      @keyup="actualizaUsuarios"
                      return-object
                      :rules="[
                        () =>
                          !!usuarioSeleccionado ||
                          'Debes seleccionar un usuario',
                      ]"
                    ></v-autocomplete>
                  </v-card-text>
                  <!--  @change="llenaUsuarioSelect" -->
                </v-row>
                <v-row>
                  <v-col sm="6">
                    <v-card-text>
                      <!-- CECO / SUCURSAL -->
                      <div class="titCampos" style="margin-top: -30px;">
                        Sucursal
                      </div>
                      <v-autocomplete
                        outlined
                        ref="cecoValue"
                        v-model="cecoSeleccionado"
                        :items="metadata.cecos"
                        item-value="ceco"
                        item-text="ceco"
                        dense
                        hide-no-data
                        placeholder="Busca una sucursal"
                        append-icon
                        :search-input.sync="textoIngresado"
                        :rules="[
                          () =>
                            !!cecoSeleccionado || 'Debes seleccionar un ceco',
                        ]"
                        @keyup="actualizaCecos"
                        @change="llenaSelectProyecto"
                        return-object
                      ></v-autocomplete>
                    </v-card-text>
                  </v-col>
                  <v-col sm="6">
                    <v-card-text>
                      <div class="titCampos" style="margin-top: -30px;">
                        Proyecto
                      </div>
                      <v-select
                        ref="proyectoValue"
                        v-model="proyectoSeleccionado"
                        dense
                        outlined
                        :items="listaProyectos"
                        item-value="proyectoSeleccionado"
                        item-text="nombreProyecto"
                        @change="llenaSelectFases"
                        return-object
                        :rules="[
                          () =>
                            !!proyectoSeleccionado ||
                            'Debes seleccionar la fecha de visita',
                        ]"
                      ></v-select>
                    </v-card-text>
                  </v-col>
                </v-row>
                <v-row>
                  <v-col sm="6">
                    <v-card-text>
                      <div class="titCampos" style="margin-top: -30px;">
                        Fase
                      </div>
                      <v-select
                        ref="faseValue"
                        v-model="faseSeleccionada"
                        dense
                        outlined
                        :items="listaFases"
                        item-value="idFase"
                        item-text="nombreFase"
                        @change="faseSeleccionadaSelect"
                        return-object
                        :rules="[
                          () =>
                            !!faseSeleccionada ||
                            'Debes seleccionar la fecha de visita',
                        ]"
                      ></v-select>
                    </v-card-text>
                  </v-col>
                  <v-col sm="6">
                    <v-card-text>
                      <!-- FECHA INICIO -->
                      <div class="titCampos" style="margin-top: -30px;">
                        Fecha de visita
                      </div>
                      <v-flex>
                        <v-menu
                          ref="menuFechaInicio"
                          v-model="menuFechaInicio"
                          :close-on-content-click="false"
                          :nudge-right="40"
                          :return-value.sync="fechaInicio"
                          transition="scale-transition"
                          offset-y
                          dense
                          outlined
                          min-width="290px"
                        >
                          <template v-slot:activator="{ on }">
                            <v-text-field
                              outlined
                              ref="dateValue"
                              dense
                              v-model="fechaInicio"
                              placeholder="Selecciona una fecha"
                              prepend-icon
                              readonly
                              v-on="on"
                              :rules="[
                                () =>
                                  !!fechaInicio ||
                                  'Debes seleccionar la fecha de visita',
                              ]"
                              prepend-inner-icon="mdi-calendar-month"
                            ></v-text-field>
                          </template>
                          <v-date-picker
                            v-model="fechaInicio"
                            no-title
                            scrollable
                            color="#ffcd00"
                          >
                            <v-spacer></v-spacer>
                            <v-btn
                              outlined
                              dense
                              text
                              color="primary"
                              @click="$refs.menuFechaInicio.save(fechaInicio)"
                              >Seleccionar</v-btn
                            >
                            <v-btn
                              text
                              color="primary"
                              @click="menuFechaInicio = false"
                              >Cancelar</v-btn
                            >
                            <v-btn
                              text
                              color="primary"
                              @click="$refs.menuFechaInicio.save(null)"
                              >Limpiar</v-btn
                            >
                          </v-date-picker>
                        </v-menu>
                      </v-flex>
                    </v-card-text>
                  </v-col>
                </v-row>
                <v-row justify="center">
                  <v-card-actions>
                    <v-btn color="primary" text @click="usuario = false"
                      >CERRAR</v-btn
                    >
                    <v-btn color="primary" text @click="enviaAsignacion"
                      >ASIGNAR</v-btn
                    >
                  </v-card-actions>
                </v-row>
              </div>
            </v-card>
          </v-dialog>
        </v-row>
      </div>
      <!-- FIN DIALOG-->
      <!-- Fin conSecc -->
    </div>
  </div>
</template>
<style scoped>
.v-text-field--box .v-input__slot,
.v-text-field--outline .v-input__slot {
  height: 10px;
}
</style>
<script>
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
export default {
  data() {
    return {
      /*DIALOG*/
      usuario: false,
      notifications: false,
      sound: true,
      widgets: false,
      cecoSeleccionado: "",
      textoIngresado: "",
      usuarioSeleccionado: "",
      idUsuarioSeleccionado: "",
      textoUsuarioIngresado: "",
      menuFechaInicio: false,
      fechaInicio: "",
      listaProyectos: [],
      proyectoSeleccionado: "",
      listaFases: [],
      faseSeleccionada: "",
      idFaseSeleccionada: "",
      idAgrupaSeleccionado: "",
      responsableAsignacion: "",
      observacionAsignacion: "",
      responsableAsigno: "",
      obsAsignacion: "",
      /*DIALOG*/
      metadata: {
        tiposRecorrido: [],
        cecos: [],
        usuarios: [],
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Infraestructura",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Asignación de Visita",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_info_recorridos",
          },
        },
      ],
    };
  },
  methods: {
    showDialog() {
      this.usuario = true;
    },
    /*CECO*/
    getCecos() {
      axios
        .get("ceco/secure/get/ceco?value=" + this.textoIngresado)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.metadata.cecos = [];
              for (var i = 0; i < response.data.data.length; i++) {
                this.metadata.cecos.push({
                  ceco:
                    response.data.data[i].descripcion +
                    " - " +
                    response.data.data[i].id_ceco,
                  idCeco: response.data.data[i].id_ceco,
                });
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      if (this.textoIngresado != null && this.textoIngresado.length > 1) {
        this.getCecos();
      } else if (this.textoIngresado == null || this.textoIngresado == "") {
        this.faseSeleccionada = "";
        this.proyectoSeleccionado = "";
        this.cecoSeleccionado = "";
      }
    },
    llenaSelectProyecto() {
      this.getInfoProyecto();
    },
    llenaSelectFases() {
      this.listaFases = [];
      this.faseSeleccionada = "";
      this.idProyectoSeleccionado = this.proyectoSeleccionado.idProyecto;
      this.getInfoFases();
    },
    faseSeleccionadaSelect() {
      this.idFaseSeleccionada = this.faseSeleccionada.ordenFase;
      this.idAgrupaSeleccionado = this.faseSeleccionada.idAgrupa;
      this.responsableAsignacion = "370566";
      this.observacionAsignacion = this.proyectoSeleccionado.negocio;
    },
    /* FIN CECOS */
    /* USUARIOS */
    getUsuarios() {
      axios
        .get("/usuario/secure/get/" + this.textoUsuarioIngresado)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.usuarios = [];
                this.metadata.usuarios.push({
                  id_usuario: response.data.data.id_usuario,
                  id_ceco: response.data.data.id_ceco,
                  nombre_usuario: response.data.data.nombre_usuario,
                  activo: response.data.data.activo,
                  dato_busqueda:
                    response.data.data.nombre_usuario +
                    " - " +
                    response.data.data.id_usuario,
                });
                this.usuarioSeleccionado = this.metadata.usuarios[0].id_usuario;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaUsuarios() {
      if (
        this.textoUsuarioIngresado != null &&
        this.textoUsuarioIngresado.length >= 4
      ) {
        this.getUsuarios();
      }
    },
    /* FIN USUARIOS */
    /* INFORMACIÓN PROYECTO CECO */
    getInfoProyecto() {
      axios
        .get(
          "/asignacion/secure/get/ceco/" +
            this.cecoSeleccionado.ceco.split(" - ")[1]
        )

        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.listaProyectos = [];
              this.listaProyectos = response.data.data;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    /* FIN INFORMACIÓN PROYECTO CECO*/
    /* INFORMACIÓN PROYECTO CECO */
    getInfoFases() {
      axios
        .post("/asignacion/secure/post/fases", {
          idProyecto: this.idProyectoSeleccionado,
          ceco: this.cecoSeleccionado.ceco.split(" - ")[1],
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.listaFases = [];
              this.listaFases = response.data.data;
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    /* FIN INFORMACIÓN PROYECTO CECO*/
    enviaAsignacion() {
      var valida = true;
      var idCeco = 0;

      if (this.usuarioSeleccionado == "") {
        this.$refs.userValue.validate(true);
        valida = false;
      }

      if (this.faseSeleccionada == "") {
        this.$refs.faseValue.validate(true);
        valida = false;
      }

      if (this.proyectoSeleccionado == "") {
        this.$refs.proyectoValue.validate(true);
        valida = false;
      }

      if (this.cecoSeleccionado == "") {
        this.$refs.cecoValue.validate(true);
        valida = false;
      } else {
        if (this.cecoSeleccionado.ceco.split(" - ").length >= 2) {
          idCeco = this.cecoSeleccionado.ceco.split(" - ")[1];
        } else {
          this.cecoSeleccionado == "";
          this.$refs.cecoValue.validate(true);
          valida = false;
        }
      }

      if (this.fechaInicio == "") {
        this.$refs.dateValue.validate(true);
        valida = false;
      }

      if (valida) {
        axios
          .post("/asignacion/secure/post/altaAsignacion", {
            idUsuario: this.usuarioSeleccionado.id_usuario,
            ceco: idCeco,
            idProyecto: this.idProyectoSeleccionado,
            responsableAsigno: this.responsableAsignacion,
            obsAsignacion: this.observacionAsignacion,
            idAgrupa: this.idAgrupaSeleccionado,
            periodo:
              this.fechaInicio.split("-")[2] +
              this.fechaInicio.split("-")[1] +
              this.fechaInicio.split("-")[0],
            faseActual: this.idFaseSeleccionada,
          })
          .then((response) => {
            //SI RES
            if (response) {
              if (response.status === 200) {
                //VALIDAR CUANDO NO SE PUEDE ASIGNAR PORQUE ESTÁ DESACTIVA VALOR == 7

                this.metadata.cecos = [];
                this.metadata.usuarios = [];
                this.listaFases = [];
                this.listaProyectos = [];
                this.fechaInicio = "";

                this.usuario = false;
                this.$refs.dateValue.resetValidation();
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {});
      }
    },
  },
  created() {},
};
</script>
